Welcome to Subscribe On Youtube

502. IPO

Description

Suppose LeetCode will start its IPO soon. In order to sell a good price of its shares to Venture Capital, LeetCode would like to work on some projects to increase its capital before the IPO. Since it has limited resources, it can only finish at most k distinct projects before the IPO. Help LeetCode design the best way to maximize its total capital after finishing at most k distinct projects.

You are given n projects where the ith project has a pure profit profits[i] and a minimum capital of capital[i] is needed to start it.

Initially, you have w capital. When you finish a project, you will obtain its pure profit and the profit will be added to your total capital.

Pick a list of at most k distinct projects from given projects to maximize your final capital, and return the final maximized capital.

The answer is guaranteed to fit in a 32-bit signed integer.

 

Example 1:

Input: k = 2, w = 0, profits = [1,2,3], capital = [0,1,1]
Output: 4
Explanation: Since your initial capital is 0, you can only start the project indexed 0.
After finishing it you will obtain profit 1 and your capital becomes 1.
With capital 1, you can either start the project indexed 1 or the project indexed 2.
Since you can choose at most 2 projects, you need to finish the project indexed 2 to get the maximum capital.
Therefore, output the final maximized capital, which is 0 + 1 + 3 = 4.

Example 2:

Input: k = 3, w = 0, profits = [1,2,3], capital = [0,1,2]
Output: 6

 

Constraints:

  • 1 <= k <= 105
  • 0 <= w <= 109
  • n == profits.length
  • n == capital.length
  • 1 <= n <= 105
  • 0 <= profits[i] <= 104
  • 0 <= capital[i] <= 109

Solutions

  • class Solution {
        public int findMaximizedCapital(int k, int w, int[] profits, int[] capital) {
            int n = capital.length;
            PriorityQueue<int[]> q1 = new PriorityQueue<>((a, b) -> a[0] - b[0]);
            for (int i = 0; i < n; ++i) {
                q1.offer(new int[] {capital[i], profits[i]});
            }
            PriorityQueue<Integer> q2 = new PriorityQueue<>((a, b) -> b - a);
            while (k-- > 0) {
                while (!q1.isEmpty() && q1.peek()[0] <= w) {
                    q2.offer(q1.poll()[1]);
                }
                if (q2.isEmpty()) {
                    break;
                }
                w += q2.poll();
            }
            return w;
        }
    }
    
  • using pii = pair<int, int>;
    
    class Solution {
    public:
        int findMaximizedCapital(int k, int w, vector<int>& profits, vector<int>& capital) {
            priority_queue<pii, vector<pii>, greater<pii>> q1;
            int n = profits.size();
            for (int i = 0; i < n; ++i) {
                q1.push({capital[i], profits[i]});
            }
            priority_queue<int> q2;
            while (k--) {
                while (!q1.empty() && q1.top().first <= w) {
                    q2.push(q1.top().second);
                    q1.pop();
                }
                if (q2.empty()) {
                    break;
                }
                w += q2.top();
                q2.pop();
            }
            return w;
        }
    };
    
  • class Solution:
        def findMaximizedCapital(
            self, k: int, w: int, profits: List[int], capital: List[int]
        ) -> int:
            h1 = [(c, p) for c, p in zip(capital, profits)]
            heapify(h1)
            h2 = []
            while k:
                while h1 and h1[0][0] <= w:
                    heappush(h2, -heappop(h1)[1])
                if not h2:
                    break
                w -= heappop(h2)
                k -= 1
            return w
    
    
  • func findMaximizedCapital(k int, w int, profits []int, capital []int) int {
    	q1 := hp2{}
    	for i, c := range capital {
    		heap.Push(&q1, pair{c, profits[i]})
    	}
    	q2 := hp{}
    	for k > 0 {
    		for len(q1) > 0 && q1[0].c <= w {
    			heap.Push(&q2, heap.Pop(&q1).(pair).p)
    		}
    		if q2.Len() == 0 {
    			break
    		}
    		w += heap.Pop(&q2).(int)
    		k--
    	}
    	return w
    }
    
    type hp struct{ sort.IntSlice }
    
    func (h hp) Less(i, j int) bool { return h.IntSlice[i] > h.IntSlice[j] }
    func (h *hp) Push(v any)        { h.IntSlice = append(h.IntSlice, v.(int)) }
    func (h *hp) Pop() any {
    	a := h.IntSlice
    	v := a[len(a)-1]
    	h.IntSlice = a[:len(a)-1]
    	return v
    }
    
    type pair struct{ c, p int }
    type hp2 []pair
    
    func (h hp2) Len() int           { return len(h) }
    func (h hp2) Less(i, j int) bool { return h[i].c < h[j].c }
    func (h hp2) Swap(i, j int)      { h[i], h[j] = h[j], h[i] }
    func (h *hp2) Push(v any)        { *h = append(*h, v.(pair)) }
    func (h *hp2) Pop() any          { a := *h; v := a[len(a)-1]; *h = a[:len(a)-1]; return v }
    

All Problems

All Solutions